#include <stdio.h> /* RTK 2008.3.5 */
#include <stdbool.h>
#define MaxStranica 50

int main(int argc, char **argv)
{
	int w, h, stolpci, x, y, najEnic, stEnic, najOp, stOp, k;
	int a[MaxStranica], *stBitov; bool obrni; char c;

	/* Preberimo vhodne podatke. */
	FILE *f = fopen(argc > 1 ? argv[1] : "toggle.in", "rt");
	fscanf(f, "%d %d\n", &w, &h);
	obrni = (h < w); /* da bo prila v eksponent kraja stranica */
	for (y = 0; y < w || y < h; y++) a[y] = 0;
	for (y = 0; y < h; y++) {
		for (x = 0; x < w; x++) {
			c = (char) fgetc(f);
			if (c == '#')
				if (obrni) a[x] |= 1 << y;
				else a[y] |= 1 << x; }
		fgetc(f); }
	fclose(f);
	if (obrni) y = w, w = h, h = y;

	/* Pripravimo si tabelo s tevilom priganih bitov
	   za vsako w-bitno celo tevilo. */
	stBitov = (int *) malloc(sizeof(int) << w);
	stBitov[0] = 0;
	for (y = 0; y < w; y++)
		for (x = 0; x < (1 << y); x++)
			stBitov[x | 1 << y] = stBitov[x] + 1;

	/* Preizkusimo vse kombinacije stolpcev, ki bi jih lahko obrnili. */
	najEnic = w * h + 1; najOp = 0;
	for (stolpci = 0; stolpci < (1 << w); stolpci++)
	{
		stEnic = 0; stOp = stBitov[stolpci];
		for (y = 0; y < h; y++) {
			k = stBitov[a[y] ^ stolpci];
			if (k <= w - k) stEnic += k;
			else stOp++, stEnic += w - k; }
		if (stEnic < najEnic || stEnic == najEnic && stOp < najOp)
			najEnic = stEnic, najOp = stOp;
	}

	/* Izpiimo rezultat. */
	f = fopen(argc > 2 ? argv[2] : "toggle.out", "wt");
	fprintf(f, "%d %d\n", najEnic, najOp); fclose(f); return 0;
}
