program Nizi; { RTK 2008.3.4 }
const MaxK = 10000; MaxDolzT = 1000000; 
var
  p: string; 
  u, t: packed array [0..MaxDolzT - 1] of char;
  F: text;
  i, j, k, n, r, pc, pd, DolzT, DolzU, StPojavitev, cPred: integer;
  { Niz t_i je shranjen v t[tp[i]..tp[i] + td[i] - 1]. 
    Podobno je del niza s, namre s[uz[i]..uz[i] + ud[i] - 1],
    shranjen v tabeli u na mestih u[up[i]..up[i] + ud[i] - 1].
    Takih kosov s-ja je r. }
  z, td, tp, uz, ud, up, tu: array [1..MaxK] of integer; c, cc: char;
  zu, zi: array [1..MaxK] of integer; { zu[j] = z[zi[j]] in tabela zu je urejena naraajoe }
  
  function SePojavlja(Kos, j: integer): boolean;
  var i: integer; sc: char;
  begin
    SePojavlja := false; if j + pd - 1 > n then exit;
    i := 1;
    while i <= pd do begin
      if Kos > r then sc := c
      else if j >= uz[Kos] + ud[kos] then begin 
        Kos := Kos + 1; continue 
      end else if j < uz[Kos] then sc := c
      else sc := u[up[Kos] + j - uz[Kos]];
      if p[i] <> sc then exit;
      i := i + 1; j := j + 1;
    end; {for i}
    SePojavlja := true;
  end; {SePojavlja}
  
begin
  { Preberimo vhodne podatke. }
  if ParamCount > 0 then Assign(F, ParamStr(1)) else Assign(F, 'nizi.in');
  Reset(F); ReadLn(F, n, k); 
  ReadLn(F, c); 
  DolzT := 0;
  for i := 1 to k do begin
    Read(F, z[i]); Read(F, cc); 
    td[i] := 0; tp[i] := DolzT;
    while not EOLn(F) do begin
      Read(F, t[DolzT]); td[i] := td[i] + 1; DolzT := DolzT + 1;
    end; {while}
    ReadLn(F);
  end; {for i}
  ReadLn(F, p); pd := Length(p); 
  Close(F);
  { Koliko c-jev je na zaetku p-ja? }
  pc := 0; while pc < pd do if p[pc + 1] = c then pc := pc + 1 else break;
  { Upotevajmo, da se t-ji lahko prekrivajo.  Uredimo jih po zaetkih. }
  for i := 1 to k do begin
    j := i - 1; 
    while j > 0 do if zu[j] <= z[i] then break
      else begin zi[j + 1] := zi[j]; zu[j + 1] := zu[j]; j := j - 1 end;
    zi[j + 1] := i; zu[j + 1] := z[i];
  end; {for i}
  { Tam, kjer se ve t-jev prekriva ali dotika, bo nastal en sam dalji kos. }
  r := 0; j := 1; DolzU := 0;
  for i := 1 to k do begin
    { Trenutni kos se kona pri j - 1; trenutni t se zane pri zu[i]. }
    if zu[i] < j then begin { Podaljajmo trenutni kos, e je treba. }
      if zu[i] + td[zi[i]] > j then j := zu[i] + td[zi[i]];
      ud[r] := j - uz[r];
    end else begin { Zanimo nov kos. }
      if r > 0 then DolzU := DolzU + ud[r];
      r := r + 1; up[r] := DolzU; uz[r] := zu[i];
      ud[r] := td[zi[i]]; j := uz[r] + ud[r];
    end; {if}
    { Kam v tabelo u bomo morali skopirati trenutni t? }
    tu[zi[i]] := up[r] + (zu[i] - uz[r]);
  end; {for i}
  DolzU := DolzU + ud[r]; 
  { Skopirajmo zdaj t-je v tabelo u. }
  for i := 1 to k do 
    for j := 1 to td[i] do
      u[tu[i] + j - 1] := t[tp[i] + j - 1];
  { Poiimo zdaj pojavitve niza v p v s. }
  StPojavitev := 0;
  for i := 1 to r do begin
    { i-ti kos niza s obsega znake s[uz[i]..uz[i] + ud[i] - 1],
      dejansko pa so shranjeni v u[up[i]..up[i] + ud[i] - 1]. 
      Med prejnjim in tem kosom je cPred znakov c. }
    if i = 1 then j := 1 else j := uz[i - 1] + ud[i - 1];
    cPred := uz[i] - j;
    { Pretejmo pojavitve p-ja med prejnjim in trenutnim kosom. }
    if (pc = pd) and (cPred >= pd) then StPojavitev := StPojavitev + cPred - pd + 1;
    { Pretejmo pojavitve p-ja, ki se zanejo v trenutnem kosu
      ali pa v vmesnem obmoju med prejnjim in trenutnim ter segajo e v trenutnega. }
    if j < uz[i] - pd + 1 then j := uz[i] - pd + 1;
    while j < uz[i] + ud[i] do begin
      if j + pd - 1 > n then break;
      if SePojavlja(i, j) then StPojavitev := StPojavitev + 1;
      j := j + 1;
    end; {while}
  end; {for i}
  { Pretejmo pojavitve p-ja za zadnjim kosom. }
  if pc = pd then begin 
    cPred := n + 1 - (uz[r] + ud[r]);
    if cPred >= pd then StPojavitev := StPojavitev + cPred - pd + 1;
  end; {if}
  { Izpiimo rezultat. }
  if ParamCount > 1 then Assign(F, ParamStr(2)) else Assign(F, 'nizi.out');
  Rewrite(F); WriteLn(F, StPojavitev); Close(F);
end. {Nizi}